// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: AreaCalc
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: AreaCalc.h,v 1.2 2013/08/27 07:29:12 rsaxton Exp $

#ifndef AreaCalc_H
#define AreaCalc_H

/* General */
#include <iostream>

/* SAS-specific */
#include "Tracer.h"

/* Local */
#include "ArfDataServer.h"
#include "PixelIterator.h"
#include "NumericalRange.h"

class AreaCalc
{
public:
  
  AreaCalc();
  
  ~AreaCalc();

  double detmapSum() const;

  const vector<double> area ( const vector<double>& energyVector );

private:

  /*** Methods */

  /* Compute area for given pixel position */
  double pixelArea( double energy, 
		    double detfrac,
		    double flux,
		    const CcdQuantumEfficiencyCurve & qecurve,	
                    const EffectiveAreaCurve & eacurve,
		    const FilterTransmissionCurve & ftcurve,
		    const ContaminantTransmissionCurve * cncurve,
                    double ootFactor ) const;

  vector<double>  missingFluxCorr( const vector<double> & area,
                         const vector<double> & eeCorrvector,
                         const vector<double> & badPixvector ) const;

  /* Member fields */

  PixelIterator * _detmapPixelIterator;
  const Frame          * _frame;
  double _detmapSum;
};

#endif
