// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: DetTableIterator
// Author: Richard Saxton
//
// Description: 
//
// Class representation of an ArrayPixelIterator that handles detector maps
//
// Modifications: See ChangeLog
// 

#ifndef DETTABLEITERATOR_H
#define DETTABLEITERATOR_H

// General classes
#include <iostream>

// SAS-specific classes
#include "Dal.h"
//#include "ConvertableData.h"
#include "errstr.h"
#include "Tracer.h"

// Local classes
#include "TablePixelIterator.h"
#include "PixelElement.h"

class DetTableIterator : public TablePixelIterator
{
public:

  /* Constructors */
  //DetTableIterator(const string & arrayname);
  DetTableIterator(const string & tablename, 
                   const string & xcolname, const string & ycolname,
                   const string & detxcolname, const string & detycolname,
                   const string & valuecolname);

  /* Destructors */
  ~DetTableIterator();

  /* Iterator methods */
  PixelElement currentItem();
  CoordPair physXYmin() const  ;
  CoordPair physXYmax() const  ;


private:

  /* Disallow default constructor */
  DetTableIterator();

  ColumnData * _detxColData;
  ColumnData * _detyColData;
  
  int16      * _detxData;
  int16      * _detyData;

};

#endif
