// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
// Module: NullEeCorrector
// Author: Hassan Siddiqui
//
// Description: 
//
// Null implementation of an Encircled Energy Corrector class
// (does nothing)
//
// Modifications: See ChangeLog
// 
// $Id: NullEeCorrector.h,v 1.1.1.1 2004/02/09 14:54:12 eojero Exp $

#ifndef NullEeCorrector_H
#define NullEeCorrector_H

/* General */

/* SAS-specific */

/* Local */
#include "EeCorrector.h"

class NullEeCorrector : public EeCorrector
{
public:

  /* Constructor */
  NullEeCorrector();

  /* Destructor */
  ~NullEeCorrector();

  vector<double> 
  Fraction( const vector<double>& energyvector) const;

private:

};

#endif
